## libphonenumber 8.12.16

=== cpp/CMakeLists.txt ===
# Copyright (C) 2011 The Libphonenumber Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Author: Philippe Liard

cmake_minimum_required (VERSION 2.8.5)

project (libphonenumber)
set (libphonenumber_VERSION_MAJOR 8)
set (libphonenumber_VERSION_MINOR 12)
set (libphonenumber_VERSION_PATCH 0)

if (32BIT)
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32")
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m32")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -m32")
endif ()

# Helper functions dealing with finding libraries and programs this library
# depends on.

include (GNUInstallDirs)
include (../tools/cpp/gtest.cmake)

function (print_error DESCRIPTION FILE)
  message (FATAL_ERROR
    "Can't find ${DESCRIPTION}: can't locate ${FILE}. Please read the README.")
endfunction ()

# Find a library. If it has not been found, stop CMake with a fatal error
# message.
function (find_required_library NAME HEADER LIBRARY DESCRIPTION)
  # Check the header.
  find_path (${NAME}_INCLUDE_DIR ${HEADER})
  set (INCLUDE_DIR ${${NAME}_INCLUDE_DIR})

  if (${INCLUDE_DIR} STREQUAL "${INCLUDE_DIR}-NOTFOUND")
    print_error (${DESCRIPTION} ${HEADER})
  endif ()
  include_directories (${INCLUDE_DIR})
  # Check the binary.
  find_library (${NAME}_LIB ${LIBRARY})
  set (LIB ${NAME}_LIB)

  if (${LIB} STREQUAL "${LIB}-NOTFOUND")
    print_error (${DESCRIPTION} ${LIBRARY})
  endif ()
endfunction (find_required_library)

# Check the library version (if pkg-config available).
find_package (PkgConfig)
function (check_library_version VARNAME LIBRARY_WITH_VERSION)
  if (PKG_CONFIG_FOUND)
    pkg_check_modules (${VARNAME} ${LIBRARY_WITH_VERSION})
  endif ()
endfunction ()

# Find a program. If it has not been found, stop CMake with a fatal error
# message.
function (find_required_program NAME FILENAME DESCRIPTION)
  find_program (${NAME}_BIN NAMES ${FILENAME})

  if (${NAME}_BIN STREQUAL "${${NAME}_BIN}-NOTFOUND")
    print_error (${DESCRIPTION} ${FILENAME})
  endif ()
endfunction (find_required_program)

# Options that can be passed to CMake using 'cmake -DKEY=VALUE'.
option ("BUILD_GEOCODER" "Build the offline phone number geocoder" "ON")
option ("REGENERATE_METADATA" "Regenerate metadata instead of using it from the source tree" "ON")
option ("USE_ALTERNATE_FORMATS" "Use alternate formats" "ON")
option ("USE_PROTOBUF_LITE" "Link to protobuf-lite" "OFF")
option ("USE_BOOST" "Use Boost" "ON")
option ("USE_ICU_REGEXP" "Use ICU regexp engine" "ON")
option ("USE_LITE_METADATA" "Use lite metadata" "OFF")
option ("USE_RE2" "Use RE2" "OFF")
option ("USE_STD_MAP" "Force the use of std::map" "OFF")
option ("BUILD_STATIC_LIB" "Build static libraries" "ON")
option ("USE_STDMUTEX" "Use C++ 2011 std::mutex for multi-threading" "OFF")
option ("USE_POSIX_THREAD" "Use Posix api for multi-threading" "OFF")

if (${USE_ALTERNATE_FORMATS} STREQUAL "ON")
  add_definitions ("-DI18N_PHONENUMBERS_USE_ALTERNATE_FORMATS")
endif ()

# Find all the required libraries and programs.
if (${USE_BOOST} STREQUAL "ON")
  add_definitions ("-DI18N_PHONENUMBERS_USE_BOOST")
  if (WIN32)
    set (Boost_USE_STATIC_LIBS ON)
  endif ()
  find_package (Boost 1.40.0 COMPONENTS date_time system thread)
  if (NOT Boost_FOUND)
    print_error ("Boost Date_Time/System/Thread" "Boost")
  endif ()
  include_directories (${Boost_INCLUDE_DIRS})
endif ()

if (${USE_STDMUTEX} STREQUAL "ON")
  add_definitions ("-DI18N_PHONENUMBERS_USE_STDMUTEX")
endif ()

if (${USE_POSIX_THREAD} STREQUAL "ON")
  add_definitions ("-DI18N_PHONENUMBERS_HAVE_POSIX_THREAD")
  find_package (Threads REQUIRED)
endif ()

if (${USE_BOOST} STREQUAL "OFF" AND ${USE_STDMUTEX} STREQUAL "OFF")
  find_package (Threads)
endif()

find_or_build_gtest ()

if (${USE_RE2} STREQUAL "ON")
  find_required_library (RE2 re2/re2.h re2 "Google RE2")
endif ()

if (${USE_PROTOBUF_LITE} STREQUAL "ON")
  find_required_library (PROTOBUF google/protobuf/message_lite.h protobuf-lite
                         "Google Protocol Buffers")
  check_library_version (PC_PROTOBUF protobuf-lite>=2.4)
else ()
  find_required_library (PROTOBUF google/protobuf/message_lite.h protobuf
                         "Google Protocol Buffers")
  check_library_version (PC_PROTOBUF protobuf>=2.4)
endif ()

find_required_library (ICU_UC unicode/uchar.h icuuc "ICU")
check_library_version (PC_ICU_UC icu-uc>=4.4)

set (ICU_INCLUDE_DIR ${ICU_UC_INCLUDE_DIR})
set (ICU_LIB ${ICU_UC_LIB})
# If ICU regexp engine is used or if the geocoder is built, use icui18n as well.
if (${USE_ICU_REGEXP} STREQUAL "ON" OR ${BUILD_GEOCODER} STREQUAL "ON")
  find_required_library (ICU_I18N unicode/regex.h icui18n "ICU")
  check_library_version (PC_ICU_I18N icu-i18n>=4.4)
  list (APPEND ICU_INCLUDE_DIR ${ICU_I18N_INCLUDE_DIR})
  list (APPEND ICU_LIB ${ICU_I18N_LIB})
endif ()

find_required_program (PROTOC protoc
                       "Google Protocol Buffers compiler (protoc)")

if (${REGENERATE_METADATA} STREQUAL "ON")
  find_required_program (JAVA java
                         "Java Runtime Environment")
endif ()

if (APPLE)
  FIND_LIBRARY (COREFOUNDATION_LIB CoreFoundation)
  FIND_LIBRARY (FOUNDATION_LIB Foundation)
  set (CMAKE_MACOSX_RPATH "OFF")
  set (CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS
    "${CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS} -undefined dynamic_lookup")
endif ()

if (${USE_STD_MAP} STREQUAL "OFF")
  INCLUDE (CheckIncludeFileCXX)
  CHECK_INCLUDE_FILE_CXX ("tr1/unordered_map" HAVE_CXX_TR1_UNORDERED_MAP)
  if (HAVE_CXX_TR1_UNORDERED_MAP)
    add_definitions ("-DI18N_PHONENUMBERS_USE_TR1_UNORDERED_MAP")
  endif ()
endif ()

# Add protoc (Protocol Buffers compiler) target.
set (RESOURCES_DIR "${CMAKE_SOURCE_DIR}/../resources")

set (
  PROTOBUF_SOURCES "${RESOURCES_DIR}/phonemetadata.proto"
                   "${RESOURCES_DIR}/phonenumber.proto"
)

set (
  PROTOBUF_OUTPUT "${CMAKE_SOURCE_DIR}/src/phonenumbers/phonemetadata.pb.cc"
                  "${CMAKE_SOURCE_DIR}/src/phonenumbers/phonemetadata.pb.h"
                  "${CMAKE_SOURCE_DIR}/src/phonenumbers/phonenumber.pb.cc"
                  "${CMAKE_SOURCE_DIR}/src/phonenumbers/phonenumber.pb.h"
)

add_custom_command (
  COMMAND ${PROTOC_BIN} --cpp_out=${CMAKE_SOURCE_DIR}/src/phonenumbers/
    --proto_path=${RESOURCES_DIR} ${PROTOBUF_SOURCES}

  OUTPUT ${PROTOBUF_OUTPUT}
  DEPENDS ${PROTOBUF_SOURCES}
)

if (${BUILD_GEOCODER} STREQUAL "ON")
  # Geocoding data cpp file generation
  set (TOOLS_DIR "${CMAKE_CURRENT_BINARY_DIR}/tools")
  add_subdirectory("${CMAKE_SOURCE_DIR}/../tools/cpp" "${TOOLS_DIR}")

  set (GEOCODING_DIR "${RESOURCES_DIR}/geocoding")
  file (GLOB_RECURSE GEOCODING_SOURCES "${GEOCODING_DIR}/*.txt")

  set (GEOCODING_DATA_OUTPUT
    "${CMAKE_SOURCE_DIR}/src/phonenumbers/geocoding/geocoding_data.cc"
  )

  add_custom_command (
    COMMAND generate_geocoding_data "${GEOCODING_DIR}"
      "${GEOCODING_DATA_OUTPUT}"

    OUTPUT ${GEOCODING_DATA_OUTPUT}
    DEPENDS ${GEOCODING_SOURCES}
            generate_geocoding_data
    COMMENT "Generating geocoding data code"
  )
endif ()

set (
  SOURCES
  "src/phonenumbers/asyoutypeformatter.cc"
  "src/phonenumbers/base/strings/string_piece.cc"
  "src/phonenumbers/default_logger.cc"
  "src/phonenumbers/logger.cc"
  "src/phonenumbers/phonemetadata.pb.cc" # Generated by Protocol Buffers.
  "src/phonenumbers/phonenumber.cc"
  "src/phonenumbers/phonenumber.pb.cc"   # Generated by Protocol Buffers.
  "src/phonenumbers/phonenumberutil.cc"
  "src/phonenumbers/regex_based_matcher.cc"
  "src/phonenumbers/regexp_cache.cc"
  "src/phonenumbers/shortnumberinfo.cc"
  "src/phonenumbers/string_byte_sink.cc"
  "src/phonenumbers/stringutil.cc"
  "src/phonenumbers/unicodestring.cc"
  "src/phonenumbers/utf/rune.c"
  "src/phonenumbers/utf/unicodetext.cc"
  "src/phonenumbers/utf/unilib.cc"
)

if (${BUILD_GEOCODER} STREQUAL "ON")
  set (
    GEOCODING_SOURCES
    "src/phonenumbers/geocoding/area_code_map.cc"
    "src/phonenumbers/geocoding/default_map_storage.cc"
    "src/phonenumbers/geocoding/geocoding_data.cc"
    "src/phonenumbers/geocoding/mapping_file_provider.cc"
    "src/phonenumbers/geocoding/phonenumber_offline_geocoder.cc"
    "src/phonenumbers/phonenumber.pb.h"  # Forces proto buffer generation.
  )
endif ()

# Add regexp engine-dependent sources. ICU is used by default.
if (${USE_RE2} STREQUAL "ON")
  # Add a flag to select the right regexp factory implementation used by
  # regexp_factory.h and regexp_adapter_test.cc.
  # When both ICU regexp and RE2 are defined, the regexp engine adapter defaults
  # to RE2 unless the ICU implementation is instantiated explictly obviously.
  add_definitions ("-DI18N_PHONENUMBERS_USE_RE2")
  list (APPEND SOURCES "src/phonenumbers/regexp_adapter_re2.cc")
endif ()

if (${USE_ICU_REGEXP} STREQUAL "ON")
  add_definitions ("-DI18N_PHONENUMBERS_USE_ICU_REGEXP")
  list (APPEND SOURCES "src/phonenumbers/regexp_adapter_icu.cc")
  # The phone number matcher needs ICU.
  list (APPEND SOURCES "src/phonenumbers/phonenumbermatch.cc")
  list (APPEND SOURCES "src/phonenumbers/phonenumbermatcher.cc")
  if (${USE_ALTERNATE_FORMATS} STREQUAL "ON")
    list (APPEND SOURCES "src/phonenumbers/alternate_format.cc")
  endif ()
endif ()

# Library sources excluding the metadata files, since special metadata is used
# for unit-testing. Note that a single testing library is built for both
# libphonenumber and geocoding.
set (TESTING_LIBRARY_SOURCES ${SOURCES})
if (${BUILD_GEOCODER} STREQUAL "ON")
  list (APPEND TESTING_LIBRARY_SOURCES ${GEOCODING_SOURCES})
endif ()

# Add metadata code generation targets.

# This function is invoked to create metadata, test metadata and lite metadata
# code generation targets.
function (add_metadata_gen_target TARGET_NAME
                                  XML_FILE
                                  METADATA_TYPE
                                  METADATA_HEADER)
  set (METADATA_SOURCE_DIR "${CMAKE_SOURCE_DIR}/src/phonenumbers")
  set (GEN_OUTPUT "${METADATA_SOURCE_DIR}/${METADATA_TYPE}.cc"
                  "${METADATA_SOURCE_DIR}/${METADATA_HEADER}.h")
  set (JAR_PATH "${CMAKE_SOURCE_DIR}/../tools/java/cpp-build/target")
  set (JAR_PATH "${JAR_PATH}/cpp-build-1.0-SNAPSHOT-jar-with-dependencies.jar")

  if (${REGENERATE_METADATA} STREQUAL "ON")
    add_custom_command (
      COMMAND ${JAVA_BIN} -jar
        ${JAR_PATH} BuildMetadataCppFromXml ${XML_FILE}
        ${CMAKE_SOURCE_DIR}/src/phonenumbers ${METADATA_TYPE}

      OUTPUT ${GEN_OUTPUT}
      DEPENDS ${XML_FILE}
    )
  else ()
    add_custom_command (
      COMMAND echo "skip metadata generation from"
        ${XML_FILE} "to"
        ${CMAKE_SOURCE_DIR}/src/phonenumbers ${METADATA_TYPE}

      OUTPUT ${GEN_OUTPUT}
      DEPENDS ${XML_FILE}
    )
  endif ()

  add_custom_target (
    ${TARGET_NAME}
    DEPENDS ${GEN_OUTPUT}
    COMMENT "Generating Metadata code"
  )
endfunction (add_metadata_gen_target)

if (${USE_LITE_METADATA} STREQUAL "ON")
  # Add the lite metadata generation target.
  set (METADATA_TARGET "generate-lite-metadata")
  add_metadata_gen_target (
    ${METADATA_TARGET}
    "${RESOURCES_DIR}/PhoneNumberMetadata.xml"
    "lite_metadata"
    "metadata"
  )
  list (APPEND SOURCES "src/phonenumbers/lite_metadata.cc")
else ()
  # Add the metadata generation target.
  set (METADATA_TARGET "generate-metadata")
  add_metadata_gen_target (
    ${METADATA_TARGET}
    "${RESOURCES_DIR}/PhoneNumberMetadata.xml"
    "metadata"
    "metadata"
  )

=== debian/changelog ===
libphonenumber (8.12.16-4) unstable; urgency=medium

  * Team upload.
  * Update Vcs-URLs to salsa.d.o
  * Depend on protobuf-api-* (Closes: #980423)
  * Add MA hint
  * simplify d/copyright

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 23 Jan 2021 21:16:40 +0100

libphonenumber (8.12.16-3) unstable; urgency=medium

  * Team upload.
  * libphonenumber-dev: Depend on libboost-thread-dev. I don't think that
    is the correct thing to do, and packages like e-d-s should declare
    that build dependency explicitly. See #978172.
  * Remove oldish version requirements in (build-)dependencies.

 -- Matthias Klose <doko@debian.org>  Wed, 20 Jan 2021 13:29:07 +0100

libphonenumber (8.12.16-2) experimental; urgency=medium

  * Team upload.
  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Tue, 19 Jan 2021 18:12:42 +0100

=== debian/control ===
Source: libphonenumber
Priority: optional
Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Fredrik Roubert <roubert@google.com>
Build-Depends: cdbs,
  cmake,
  debhelper (>= 11),
  default-jdk | java-sdk,
  default-jdk-doc,
  libgtest-dev,
  libicu-dev,
  libprotobuf-dev,
  libre2-dev,
  maven-debian-helper,
  protobuf-compiler,
  junit4,
  libbuild-helper-maven-plugin-java,
  libmaven-antrun-plugin-java,
  libmaven-assembly-plugin-java,
  libmaven-compiler-plugin-java,
  libmaven-exec-plugin-java,
  libmaven-jar-plugin-java,
  libmaven-javadoc-plugin-java,
  libmaven-war-plugin-java,
  libmaven-bundle-plugin-java,
  libprotobuf-java,
  libservlet3.1-java,
  libservlet3.1-java-doc
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/googlei18n/libphonenumber/
Vcs-Browser: https://salsa.debian.org/debian/libphonenumber
Vcs-Git: https://salsa.debian.org/debian/libphonenumber.git

Package: libphonenumber8-java
Section: java
Architecture: all
Conflicts: libphonenumber6-java, libphonenumber-java, libphonenumber7-java,
Replaces: libphonenumber6-java, libphonenumber-java, libphonenumber7-java,
Depends: ${misc:Depends}, ${maven:Depends}
Recommends: ${maven:OptionalDepends}
Description: parsing/formatting/validating phone numbers - java
 Google's common C++ and Java library for parsing, formatting, storing and
 validating international phone numbers.
 .
 This package contains the runtime library JARs for Java users.

Package: libphonenumber-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Conflicts: libphonenumber6-dev
Replaces: libphonenumber6-dev
Depends: libphonenumber8 (= ${binary:Version}),
  libgeocoding8 (= ${binary:Version}),
  ${misc:Depends},
  ${protobuf:API},
  libboost-thread-dev,   
Description: parsing/formatting/validating phone numbers - development files
 Google's common C++ and Java library for parsing, formatting, storing and
 validating international phone numbers.
 .
 This package contains the static libraries and include files.

Package: libphonenumber8
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: parsing/formatting/validating phone numbers
 Google's common C++ and Java library for parsing, formatting, storing and
 validating international phone numbers.
 .
 This package contains the runtime libraries for C++ users.

Package: libgeocoding8
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: geocoding phone numbers
 Google's library for geocoding phone international phone numbers.
 .
 This package contains the runtime libraries which can be used to geocode phone
 numbers. This means obtaining a desciption (for example of the location) of a
 given phone number.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Copyright (C) 2011 The Libphonenumber Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/maven.mk

JAVA_HOME := /usr/lib/jvm/default-java
DEB_MAVEN_DOC_TARGET := javadoc:jar javadoc:aggregate

CMAKE ?= cmake

CMAKE_FLAGS := -DCMAKE_INSTALL_PREFIX=/usr -DUSE_BOOST=OFF -DCMAKE_VERBOSE_MAKEFILE=TRUE
CPP_BUILD := cpp/build
JAVA_BUILD := java/build

# CMake doesn't read CPPFLAGS and dh_auto commands are not used in this rules
# file so we have to manually set the flags here to ensure that hardening flags
# are used:
export CFLAGS := -pthread $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := -pthread $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS := -pthread $(shell dpkg-buildflags --get LDFLAGS)

$(warning CFLAGS: $(CFLAGS))
$(warning CXXFLAGS: $(CXXFLAGS))
$(warning LDFLAGS: $(LDFLAGS))

ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
  INSTALL_PROGRAM += -s
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(NUMJOBS)
endif

# see #980423
# extract the protobuf API version package and add it to d/control
# Needed because protobuf generated headers are only compatible with that version
protobufapi := $(shell dpkg-query -W -f '$${Provides}' libprotobuf-dev | grep -o 'protobuf-api-[^ ]*')

#%:
#	dh $@ --with javahelper

#override_dh_auto_configure:
configure/libphonenumber8::
	mkdir -p $(CPP_BUILD) && cd $(CPP_BUILD) && $(CMAKE) $(CMAKE_FLAGS) ..

#override_dh_auto_build:
#	( cd tools/java && $(MVN) package )
#	mkdir java/lib
#	ln -s /usr/share/java/junit4.jar java/lib/junit-4.8.1.jar
#	$(ANT) -f $(JAVA_BUILD).xml jar
build/libphonenumber8::
	ln -sf cpp-build-1.0-SNAPSHOT.jar tools/java/cpp-build/target/cpp-build-1.0-SNAPSHOT-jar-with-dependencies.jar
	ln -sf /usr/share/java/protobuf.jar tools/java/cpp-build/target/protobuf-java-debian.jar
	$(MAKE) -C $(CPP_BUILD) phonenumber phonenumber-shared

#override_dh_auto_test:
#ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
#	$(MAKE) -C $(CPP_BUILD) test
#	$(ANT) -f $(JAVA_BUILD).xml junit
#endif

# Hack for multiarch: CMake doesn't really support libdir so we just manually
# move /usr/lib/* to a proper multiarch location.
#override_dh_auto_install:
common-install-arch::
	dh_auto_install --builddirectory=$(CPP_BUILD)
	echo 'protobuf:API=$(protobufapi)' >> debian/libphonenumber-dev.substvars

#override_dh_auto_clean:
clean::
	-test -d $(CPP_BUILD) && $(MAKE) -C $(CPP_BUILD) clean
	rm -rf cpp/build
	#-$(ANT) -f $(JAVA_BUILD).xml clean
	#-( cd tools/java && $(MVN) clean )

## libphonenumber 8.12.44

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,12 @@
 
 # Author: Philippe Liard
 
-cmake_minimum_required (VERSION 2.8.5)
+cmake_minimum_required (VERSION 3.11)
+
+# Pick the C++ standard to compile with.
+# Abseil currently supports C++11, C++14, and C++17.
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 project (libphonenumber)
 set (libphonenumber_VERSION_MAJOR 8)
@@ -175,7 +180,7 @@
 endif ()
 
 # Add protoc (Protocol Buffers compiler) target.
-set (RESOURCES_DIR "${CMAKE_SOURCE_DIR}/../resources")
+set (RESOURCES_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../resources")
 
 set (
   PROTOBUF_SOURCES "${RESOURCES_DIR}/phonemetadata.proto"
@@ -183,14 +188,14 @@
 )
 
 set (
-  PROTOBUF_OUTPUT "${CMAKE_SOURCE_DIR}/src/phonenumbers/phonemetadata.pb.cc"
-                  "${CMAKE_SOURCE_DIR}/src/phonenumbers/phonemetadata.pb.h"
-                  "${CMAKE_SOURCE_DIR}/src/phonenumbers/phonenumber.pb.cc"
-                  "${CMAKE_SOURCE_DIR}/src/phonenumbers/phonenumber.pb.h"
+  PROTOBUF_OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/phonemetadata.pb.cc"
+                  "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/phonemetadata.pb.h"
+                  "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/phonenumber.pb.cc"
+                  "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/phonenumber.pb.h"
 )
 
 add_custom_command (
-  COMMAND ${PROTOC_BIN} --cpp_out=${CMAKE_SOURCE_DIR}/src/phonenumbers/
+  COMMAND ${PROTOC_BIN} --cpp_out=${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/
     --proto_path=${RESOURCES_DIR} ${PROTOBUF_SOURCES}
 
   OUTPUT ${PROTOBUF_OUTPUT}
@@ -200,13 +205,13 @@
 if (${BUILD_GEOCODER} STREQUAL "ON")
   # Geocoding data cpp file generation
   set (TOOLS_DIR "${CMAKE_CURRENT_BINARY_DIR}/tools")
-  add_subdirectory("${CMAKE_SOURCE_DIR}/../tools/cpp" "${TOOLS_DIR}")
+  add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/../tools/cpp" "${TOOLS_DIR}")
 
   set (GEOCODING_DIR "${RESOURCES_DIR}/geocoding")
   file (GLOB_RECURSE GEOCODING_SOURCES "${GEOCODING_DIR}/*.txt")
 
   set (GEOCODING_DATA_OUTPUT
-    "${CMAKE_SOURCE_DIR}/src/phonenumbers/geocoding/geocoding_data.cc"
+    "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/geocoding/geocoding_data.cc"
   )
 
   add_custom_command (
@@ -290,17 +295,17 @@
                                   XML_FILE
                                   METADATA_TYPE
                                   METADATA_HEADER)
-  set (METADATA_SOURCE_DIR "${CMAKE_SOURCE_DIR}/src/phonenumbers")
+  set (METADATA_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers")
   set (GEN_OUTPUT "${METADATA_SOURCE_DIR}/${METADATA_TYPE}.cc"
                   "${METADATA_SOURCE_DIR}/${METADATA_HEADER}.h")
-  set (JAR_PATH "${CMAKE_SOURCE_DIR}/../tools/java/cpp-build/target")
+  set (JAR_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../tools/java/cpp-build/target")
   set (JAR_PATH "${JAR_PATH}/cpp-build-1.0-SNAPSHOT-jar-with-dependencies.jar")
 
   if (${REGENERATE_METADATA} STREQUAL "ON")
     add_custom_command (
       COMMAND ${JAVA_BIN} -jar
         ${JAR_PATH} BuildMetadataCppFromXml ${XML_FILE}
-        ${CMAKE_SOURCE_DIR}/src/phonenumbers ${METADATA_TYPE}
+        ${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers ${METADATA_TYPE}
 
       OUTPUT ${GEN_OUTPUT}
       DEPENDS ${XML_FILE}
@@ -309,7 +314,7 @@
     add_custom_command (
       COMMAND echo "skip metadata generation from"
         ${XML_FILE} "to"
-        ${CMAKE_SOURCE_DIR}/src/phonenumbers ${METADATA_TYPE}
+        ${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers ${METADATA_TYPE}
 
       OUTPUT ${GEN_OUTPUT}
       DEPENDS ${XML_FILE}
@@ -334,11 +339,3 @@
   )
   list (APPEND SOURCES "src/phonenumbers/lite_metadata.cc")
 else ()
-  # Add the metadata generation target.
-  set (METADATA_TARGET "generate-metadata")
-  add_metadata_gen_target (
-    ${METADATA_TARGET}
-    "${RESOURCES_DIR}/PhoneNumberMetadata.xml"
-    "metadata"
-    "metadata"
-  )

=== tools/cpp/CMakeLists.txt ===
# Copyright (C) 2012 The Libphonenumber Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Author: Patrick Mezard

cmake_minimum_required (VERSION 3.11)

# Pick the C++ standard to compile with.
# Abseil currently supports C++11, C++14, and C++17.
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project (generate_geocoding_data)

# Helper functions dealing with finding libraries and programs this library
# depends on.
include (gtest.cmake)
include (FetchContent)

# Downloading the abseil sources.
FetchContent_Declare(
    abseil-cpp
    GIT_REPOSITORY  https://github.com/abseil/abseil-cpp.git
    GIT_TAG         origin/master
)

# Building the abseil binaries
FetchContent_GetProperties(abseil-cpp)
if (NOT abseil-cpp_POPULATED)
    FetchContent_Populate(abseil-cpp)
endif ()

if (NOT abseil-cpp_POPULATED)
   message (FATAL_ERROR "Could not build abseil-cpp binaries.")
endif ()

# Safeguarding against any potential link errors as mentioned in
# https://github.com/abseil/abseil-cpp/issues/225
set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
add_subdirectory(${abseil-cpp_SOURCE_DIR} ${abseil-cpp_BINARY_DIR})

find_or_build_gtest ()
set (
  SOURCES
  "src/cpp-build/generate_geocoding_data.cc"
  "src/cpp-build/generate_geocoding_data_main.cc"
)

if (NOT WIN32)
  add_definitions ("-Wall -Werror")
endif ()

include_directories ("src")

add_executable (generate_geocoding_data ${SOURCES})
target_link_libraries (generate_geocoding_data absl::strings absl::btree)

set (TEST_SOURCES
  "src/cpp-build/generate_geocoding_data.cc"
  "test/cpp-build/generate_geocoding_data_test.cc"
  "test/cpp-build/run_tests.cc"
)

set (TEST_LIBS ${GTEST_LIB})

if (NOT WIN32)
  list (APPEND TEST_LIBS pthread)
endif ()

# Build the testing binary.
include_directories ("test")
add_executable (generate_geocoding_data_test ${TEST_SOURCES})
target_link_libraries (generate_geocoding_data_test absl::btree ${TEST_LIBS})

=== debian/changelog ===
libphonenumber (8.12.44-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.44
    Metadata changes:
     - Updated phone metadata for region code(s):
       AG, AI, AS, BB, BM, BS, CA, CV, DM, DO, GD, GU, JM, KN, KY, LC, MP, MS, PR,
       SC, SX, TC, TT, US, VC, VG, VI
     - Updated short number metadata for region code(s): BE, PT, SC, SE, US
     - Updated geocoding data for country calling code(s):
       61 (en), 238 (en), 1345 (en)
     - Updated carrier data for country calling code(s): 238 (en), 248 (en)

 -- tony mancill <tmancill@debian.org>  Thu, 24 Feb 2022 06:56:52 -0800

libphonenumber (8.12.43-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.43
    Metadata changes:
    - Updated phone metadata for region code(s):
        BJ, CL, GA, IS, KR, KW, LI, PA, SG, SL
    - Updated short number metadata for region code(s): MS
    - Updated geocoding data for country calling code(s): 56 (en, es)
    - Updated carrier data for country calling code(s):
        32 (en), 229 (en), 354 (en), 502 (en), 507 (en)

 -- tony mancill <tmancill@debian.org>  Wed, 16 Feb 2022 20:57:19 -0800

libphonenumber (8.12.42-2) unstable; urgency=medium

  * Team upload.
  * libphonenumber-dev: add dependency on libabsl-dev (Closes: #1005157)

 -- tony mancill <tmancill@debian.org>  Tue, 08 Feb 2022 07:14:02 -0800

libphonenumber (8.12.42-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.42
  * Refresh patches for new upstream version
  * Drop unnecessary JDK5 5 compilation patch

 -- tony mancill <tmancill@debian.org>  Mon, 31 Jan 2022 20:03:33 -0800

libphonenumber (8.12.41-2) unstable; urgency=medium

  * Team upload.
  * Eliminate build parallelism to try to work around build failures

 -- tony mancill <tmancill@debian.org>  Fri, 28 Jan 2022 14:35:18 -0800

libphonenumber (8.12.41-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.41 (Closes: #1003972)
  * Add build-dep on libabsl-dev
  * Add patch to build against Debian packaging of abseil
  * Replace obsolete libservlet3.1-java with libservlet-api-java
    and remove maven.rules entry that remapped javax.servlet
  * Drop needless build-dep on libservlet3.1-java-doc

 -- tony mancill <tmancill@debian.org>  Thu, 27 Jan 2022 07:48:33 -0800

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
   debhelper (>= 11),
   default-jdk | java-sdk,
   default-jdk-doc,
+  libabsl-dev,
   libgtest-dev,
   libicu-dev,
   libprotobuf-dev,
@@ -24,8 +25,7 @@
   libmaven-war-plugin-java,
   libmaven-bundle-plugin-java,
   libprotobuf-java,
-  libservlet3.1-java,
-  libservlet3.1-java-doc
+  libservlet-api-java
 Standards-Version: 4.5.1
 Section: libs
 Homepage: https://github.com/googlei18n/libphonenumber/
@@ -55,7 +55,8 @@
   libgeocoding8 (= ${binary:Version}),
   ${misc:Depends},
   ${protobuf:API},
-  libboost-thread-dev,   
+  libboost-thread-dev,
+  libabsl-dev,
 Description: parsing/formatting/validating phone numbers - development files
  Google's common C++ and Java library for parsing, formatting, storing and
  validating international phone numbers.

=== debian/rules ===
--- 
+++ 
@@ -44,8 +44,13 @@
 ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
   INSTALL_PROGRAM += -s
 endif
+
+# disable parallelism during build in an attempt to resolve build failures
+# see: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1003972#51
+export CMAKE_BUILD_PARALLEL_LEVEL := 1
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+  #NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+  NUMJOBS = 1
   MAKEFLAGS += -j$(NUMJOBS)
 endif
 
@@ -81,7 +86,7 @@
 # move /usr/lib/* to a proper multiarch location.
 #override_dh_auto_install:
 common-install-arch::
-	dh_auto_install --builddirectory=$(CPP_BUILD)
+	dh_auto_install --builddirectory=$(CPP_BUILD) --no-parallel
 	echo 'protobuf:API=$(protobufapi)' >> debian/libphonenumber-dev.substvars
 
 #override_dh_auto_clean:

=== debian/watch ===
version=3
https://github.com/googlei18n/libphonenumber/tags \
  .*/libphonenumber/archive/.*?(\d[\d\.]+).*\.tar\.gz

## libphonenumber 8.12.54+ds

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
 
 # Pick the C++ standard to compile with.
 # Abseil currently supports C++11, C++14, and C++17.
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 11 CACHE STRING "C++ standard used to compile this project")
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 project (libphonenumber)
@@ -203,6 +203,8 @@
 )
 
 if (${BUILD_GEOCODER} STREQUAL "ON")
+  find_package(absl)
+
   # Geocoding data cpp file generation
   set (TOOLS_DIR "${CMAKE_CURRENT_BINARY_DIR}/tools")
   add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/../tools/cpp" "${TOOLS_DIR}")
@@ -337,5 +339,3 @@
     "lite_metadata"
     "metadata"
   )
-  list (APPEND SOURCES "src/phonenumbers/lite_metadata.cc")
-else ()

=== debian/changelog ===
libphonenumber (8.12.54+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.54+ds
    Metadata changes:
     - Updated phone metadata for region code(s): BE, BF, GE, HN, MX, PT, US
     - Updated geocoding data for country calling code(s):
       52 (en), 61 (en), 351 (en)
     - Updated carrier data for country calling code(s):
       226 (en), 351 (en), 420 (en), 992 (en), 995 (en)
  * Remove unnecessary Java 5 patch

 -- tony mancill <tmancill@debian.org>  Thu, 25 Aug 2022 12:08:01 -0700

libphonenumber (8.12.53+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.52+ds
    Metadata changes:
     - Updated alternate formatting data for country calling code(s): 49
     - Updated phone metadata for region code(s):
       BW, DE, ET, HK, ML, MN, MQ, NP, PE, QA, SG
     - Updated geocoding data for country calling code(s): 61 (en)
     - Updated carrier data for country calling code(s):
       48 (en), 65 (en), 223 (en), 251 (en), 852 (en, zh), 976 (en), 977 (en)

  * New upstream version 8.12.53+ds
    Metadata changes:
     - Updated phone metadata for region code(s):
       AT, BE, CL, CN, GE, GF, GH, HK, JM, PG, RE, US
     - Updated short number metadata for region code(s): AT
     - New geocoding data for country calling code(s): 1943 (en)
     - Updated carrier data for country calling code(s):
       34 (en), 56 (en), 57 (en), 86 (en), 233 (en), 972 (en), 992 (en)
     - Updated / refreshed time zone meta data.

 -- tony mancill <tmancill@debian.org>  Sun, 07 Aug 2022 16:29:23 -0700

libphonenumber (8.12.51+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.51+ds
    Metadata changes:
     - Updated phone metadata for region code(s):
       800, BJ, BR, CO, EH, FO, GE, GP, KE, KG, MA, MM, MN, MY, NZ, RE, SI,
       UG, VN
     - Updated geocoding data for country calling code(s): 57 (en), 61 (en)
     - Updated carrier data for country calling code(s):
       60 (en), 254 (en), 262 (en), 298 (en), 386 (en), 421 (en), 976 (en),
       995 (en), 996 (en)
     - Updated / refreshed time zone meta data.

 -- tony mancill <tmancill@debian.org>  Wed, 06 Jul 2022 07:02:47 -0700

libphonenumber (8.12.50+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.50+ds
    Metadata changes:
     - Updated alternate formatting data for country calling codes: 380, 49
     - Updated phone metadata for region code(s):
       AR, CL, DE, EH, GB, HK, HR, IR, IT, MA, MH, TT, UA, US
     - New geocoding data for country calling code(s): 1826 (en)
     - Updated geocoding data for country calling code(s):
       34 (en, es), 54 (en), 61 (en)
     - Updated carrier data for country calling code(s):
       44 (en), 98 (en, fa), 212 (en), 380 (en, uk), 385 (en), 420 (en),
       852 (en, zh)
     - Updated / refreshed time zone meta data.
    New Metadata files:
     - The phone and short number metadata of all regions are available now
       in CSV format, at resources/metdata directory.
       (These are available in the Debian source package, but do not affect
       the binary packages generated from the sources.)

 -- tony mancill <tmancill@debian.org>  Sat, 25 Jun 2022 07:37:10 -0700

libphonenumber (8.12.49+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.49+ds
    Metadata changes:
     - Updated phone metadata for region code(s):
       CA, CM, GB, IL, JM, JP, MA, MV, PG, US
     - Updated geocoding data for country calling code(s):
       33 (en), 44 (en), 212 (en, fr), 1310 (en)
     - Updated carrier data for country calling code(s):
       237 (en), 675 (en)
     - Updated / refreshed time zone meta data.

 -- tony mancill <tmancill@debian.org>  Fri, 03 Jun 2022 22:08:10 -0700

libphonenumber (8.12.48+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.48
    release notes: https://github.com/google/libphonenumber/pull/2767
  * Update debian/copyright to exclude JAR files from upstream sources
    and update debian/watch to repack with +ds version suffix.

 -- tony mancill <tmancill@debian.org>  Sat, 07 May 2022 21:15:08 -0700

libphonenumber (8.12.47-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.47
  * Refresh patches for new upstream version
  * Add build-dep on libmockito-java

 -- tony mancill <tmancill@debian.org>  Fri, 22 Apr 2022 07:20:10 -0700

libphonenumber (8.12.46-2) unstable; urgency=medium

  * Team upload.
  * Add patch to resolve FTBFS for reverse build-deps (Closes: #1008817)
    - Thank you to Adrian Bunk and Christoph Anton Mitterer.

 -- tony mancill <tmancill@debian.org>  Sat, 02 Apr 2022 10:43:51 -0700

libphonenumber (8.12.46-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.46
    Metadata changes:
     - Updated phone metadata for region code(s): BJ, JM, PW, SA
     - Updated short number metadata for region code(s): HU
     - Updated carrier data for country calling code(s):
       36 (en), 51 (en), 61 (en), 90 (en), 229 (en), 254 (en), 680 (en),
       966 (en)
  * Changelog from upstream version 8.12.45 (not released for Debian)
    Metadata changes:
     - Updated phone metadata for region code(s): BF, EE, JM, RE, SE, US
     - New geocoding data for country calling code(s): 1464 (en)
     - Updated carrier data for country calling code(s):
       46 (en), 55 (en), 226 (en), 262 (en), 353 (en), 372 (en), 373 (en),
       1345 (en)
     - Updated / refreshed time zone meta data.

 -- tony mancill <tmancill@debian.org>  Fri, 01 Apr 2022 09:53:47 -0700

=== debian/control ===
--- 
+++ 
@@ -24,6 +24,7 @@
   libmaven-javadoc-plugin-java,
   libmaven-war-plugin-java,
   libmaven-bundle-plugin-java,
+  libmockito-java,
   libprotobuf-java,
   libservlet-api-java
 Standards-Version: 4.5.1
@@ -31,6 +32,7 @@
 Homepage: https://github.com/googlei18n/libphonenumber/
 Vcs-Browser: https://salsa.debian.org/debian/libphonenumber
 Vcs-Git: https://salsa.debian.org/debian/libphonenumber.git
+Rules-Requires-Root: no
 
 Package: libphonenumber8-java
 Section: java

## libphonenumber 8.12.57%2Bds

=== debian/control ===
Source: libphonenumber
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Fredrik Roubert <roubert@google.com>
Build-Depends:
  cmake,
  debhelper-compat (= 13),
  dh-sequence-javahelper,
  default-jdk,
  default-jdk-doc,
  dpkg-dev (>= 1.22.5),
  libabsl-dev (>= 20220623.1-3.1),
  libgtest-dev,
  libicu-dev,
  libprotobuf-dev,
  libre2-dev,
  maven-debian-helper,
  protobuf-compiler,
  junit4,
  libbuild-helper-maven-plugin-java,
  libmaven-antrun-plugin-java,
  libmaven-assembly-plugin-java,
  libmaven-compiler-plugin-java,
  libmaven-exec-plugin-java,
  libmaven-jar-plugin-java,
  libmaven-javadoc-plugin-java,
  libmaven-war-plugin-java,
  libmaven-bundle-plugin-java,
  libmockito-java,
  libprotobuf-java,
  libservlet-api-java
Standards-Version: 4.6.1
Section: libs
Homepage: https://github.com/googlei18n/libphonenumber/
Vcs-Browser: https://salsa.debian.org/debian/libphonenumber
Vcs-Git: https://salsa.debian.org/debian/libphonenumber.git
Rules-Requires-Root: no
Description: parsing/formatting/validating phone numbers
 Google's common C++ and Java library for parsing, formatting, storing and
 validating international phone numbers.

Package: libphonenumber8-java
Section: java
Architecture: all
Conflicts: libphonenumber7-java,
Replaces: libphonenumber7-java,
Depends: ${misc:Depends}, ${maven:Depends}
Recommends: ${maven:OptionalDepends}
Description: ${source:Synopsis} - java
 ${source:Extended-Description}
 .
 This package contains the runtime library JARs for Java users.

Package: libphonenumber-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libphonenumber8 (= ${binary:Version}),
  libgeocoding8 (= ${binary:Version}),
  ${misc:Depends},
  ${protobuf:API},
  libboost-thread-dev,
  libabsl-dev,
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 This package contains the static libraries and include files.

Package: libphonenumber8
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ${libphonenumber:Provides}
Multi-Arch: same
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains the runtime libraries for C++ users.

Package: libgeocoding8
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: geocoding phone numbers
 Google's library for geocoding phone international phone numbers.
 .
 This package contains the runtime libraries which can be used to geocode phone
 numbers. This means obtaining a description (for example of the location) of a
 given phone number.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@

# see #980423
# extract the protobuf API version package and add it to d/control
# Needed because protobuf generated headers are only compatible with that version
protobufapi := $(shell dpkg-query -W -f '$${Provides}' libprotobuf-dev | grep -o 'protobuf-api-[^ ]*')

# virtual package to represent libphonenumber and protobuf ABI
protobufabi := $(shell dpkg-query -W -f '$${Depends}' libprotobuf-dev | sed -n 's/.*libprotobuf\([0-9]*\)\(t64\)\? .*/\1/p')
phonenumberprotoabi := libphonenumber8t64-protobuf$(protobufabi)
ifneq (,$(filter 64,$(DEB_HOST_ARCH_BITS))$(filter i386,$(DEB_HOST_ARCH)))
  phonenumberprotocompatabi := , libphonenumber8-protobuf$(protobufabi)
endif

execute_before_dh_gencontrol:
	echo 'libphonenumber:Provides=$(phonenumberprotoabi)$(phonenumberprotocompatabi)' >> debian/libphonenumber8.substvars
	echo 'protobuf:API=$(protobufapi)' >> debian/libphonenumber-dev.substvars

override_dh_makeshlibs:
	dh_makeshlibs -plibphonenumber8 -V '$(phonenumberprotoabi)'
	dh_makeshlibs --remaining-packages

# workaround cpp lib (arch any) depending on java lib (arch all)
override_dh_auto_configure:
	DH_INTERNAL_OPTIONS= dh_auto_configure -i -plibphonenumber8-java
	dh_auto_configure --sourcedirectory=cpp -- -DUSE_BOOST=OFF

# disable parallelism during build in an attempt to resolve build failures
# see: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1003972#51
override_dh_auto_build:
	DH_INTERNAL_OPTIONS= dh_auto_build -i -plibphonenumber8-java
	ln -sf cpp-build-1.0-SNAPSHOT.jar tools/java/cpp-build/target/cpp-build-1.0-SNAPSHOT-jar-with-dependencies.jar
	ln -sf /usr/share/java/protobuf.jar tools/java/cpp-build/target/protobuf-java-debian.jar
	dh_auto_build --sourcedirectory=cpp --no-parallel

override_dh_auto_test-arch:
	dh_auto_test --sourcedirectory=cpp

override_dh_auto_install-arch:
	dh_auto_install --sourcedirectory=cpp

override_dh_auto_clean-arch:
	dh_auto_clean --sourcedirectory=cpp

## libphonenumber 8.12.57+ds

=== tools/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -28,27 +28,30 @@
 include (gtest.cmake)
 include (FetchContent)
 
-# Downloading the abseil sources.
-FetchContent_Declare(
-    abseil-cpp
-    GIT_REPOSITORY  https://github.com/abseil/abseil-cpp.git
-    GIT_TAG         origin/master
-)
+if(NOT absl_FOUND)
+  # Downloading the abseil sources at particular version to not catch up
+  # with its new build requirements like min C++14 is mandated in that lib.
+  FetchContent_Declare(
+      abseil-cpp
+      GIT_REPOSITORY  https://github.com/abseil/abseil-cpp.git
+      GIT_TAG         273292d
+  )
 
-# Building the abseil binaries
-FetchContent_GetProperties(abseil-cpp)
-if (NOT abseil-cpp_POPULATED)
-    FetchContent_Populate(abseil-cpp)
-endif ()
+  # Building the abseil binaries
+  FetchContent_GetProperties(abseil-cpp)
+  if (NOT abseil-cpp_POPULATED)
+      FetchContent_Populate(abseil-cpp)
+  endif ()
 
-if (NOT abseil-cpp_POPULATED)
-   message (FATAL_ERROR "Could not build abseil-cpp binaries.")
-endif ()
+  if (NOT abseil-cpp_POPULATED)
+     message (FATAL_ERROR "Could not build abseil-cpp binaries.")
+  endif ()
 
-# Safeguarding against any potential link errors as mentioned in
-# https://github.com/abseil/abseil-cpp/issues/225
-set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
-add_subdirectory(${abseil-cpp_SOURCE_DIR} ${abseil-cpp_BINARY_DIR})
+  # Safeguarding against any potential link errors as mentioned in
+  # https://github.com/abseil/abseil-cpp/issues/225
+  set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
+  add_subdirectory(${abseil-cpp_SOURCE_DIR} ${abseil-cpp_BINARY_DIR})
+endif()
 
 find_or_build_gtest ()
 set (
@@ -64,7 +67,7 @@
 include_directories ("src")
 
 add_executable (generate_geocoding_data ${SOURCES})
-target_link_libraries (generate_geocoding_data absl::strings absl::btree)
+target_link_libraries (generate_geocoding_data absl::strings absl::btree absl::node_hash_set)
 
 set (TEST_SOURCES
   "src/cpp-build/generate_geocoding_data.cc"
@@ -81,4 +84,4 @@
 # Build the testing binary.
 include_directories ("test")
 add_executable (generate_geocoding_data_test ${TEST_SOURCES})
-target_link_libraries (generate_geocoding_data_test absl::btree ${TEST_LIBS})
+target_link_libraries (generate_geocoding_data_test absl::btree ${TEST_LIBS} absl::node_hash_set)

=== debian/changelog ===
libphonenumber (8.12.57+ds-3) unstable; urgency=medium

  * Team upload.
  * Add patch to link geocoding-shared with phonenumber-shared
    (Closes: #1017496)
  * Build java lib in arch any builds (Closes: #1024768)

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 24 Nov 2022 20:17:13 +0100

libphonenumber (8.12.57+ds-2) unstable; urgency=medium

  * Team upload.
  * Convert to debhelper
  * Expose protobuf ABI (Closes: #1024701)
  * Bump policy version (no changes)
  * Move package description to source package
  * Drop old Conflicts/Replaces

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 24 Nov 2022 12:03:20 +0100

libphonenumber (8.12.57+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.57+ds
    Metadata changes:
     - Updated phone metadata for region code(s):
       BJ, EH, GB, GF, GG, JE, MA, MW, SG, SN, SO, ZM
     - Updated geocoding data for country calling code(s): 229 (en)
     - Updated carrier data for country calling code(s):
       27 (en), 34 (en), 47 (en), 65 (en), 212 (en), 252 (en),
       260 (en), 594 (en), 974 (en)
     - Updated / refreshed time zone meta data.

 -- tony mancill <tmancill@debian.org>  Fri, 14 Oct 2022 17:57:01 -0700

libphonenumber (8.12.56+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.56+ds
    Metadata changes:
     - Updated phone metadata for region code(s): HR, MK, PT, SG, TT
     - Updated short number metadata for region code(s): BZ
     - Updated carrier data for country calling code(s):
       31 (en), 65 (en), 385 (en), 389 (en)

 -- tony mancill <tmancill@debian.org>  Fri, 23 Sep 2022 08:43:20 -0700

libphonenumber (8.12.55+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 8.12.55+ds
    Metadata changes:
     - Updated phone metadata for region code(s):
       AU, CA, CC, CI, CO, CX, DE, HK, KW, LV, MV, PA, PL, TZ, US
     - Updated short number metadata for region code(s): CO, TZ
     - New geocoding data for country calling code(s): 1742 (en), 1753 (en)
     - Updated geocoding data for country calling code(s):
       57 (en), 225 (en), 960 (en)
     - New carrier data for country calling code(s): 371 (en)
     - Updated carrier data for country calling code(s):
       47 (en), 57 (en), 61 (en), 90 (en), 255 (en), 297 (en), 381 (en),
       420 (en), 972 (en), 974 (en)
     - Updated / refreshed time zone meta data.

 -- tony mancill <tmancill@debian.org>  Fri, 09 Sep 2022 07:32:21 -0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: libphonenumber
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
 Uploaders: Fredrik Roubert <roubert@google.com>
 Build-Depends:
   cmake,
@@ -9,8 +8,7 @@
   dh-sequence-javahelper,
   default-jdk,
   default-jdk-doc,
-  dpkg-dev (>= 1.22.5),
-  libabsl-dev (>= 20220623.1-3.1),
+  libabsl-dev,
   libgtest-dev,
   libicu-dev,
   libprotobuf-dev,
